package at.ac.uibk.gitsearch.service;

import java.io.IOException;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.junit.Assert;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import at.ac.uibk.gitsearch.GitsearchApp;

@SpringBootTest(classes = GitsearchApp.class)
public class ShoppingBasketServiceIT {
	
	private static final String TEST_ZIP_LOCATION = "./testData/junit-quality-tests-exercise-master.zip";
	@Autowired
	protected ShoppingBasketService shoppingBasketService;
	
	private final Logger log = LoggerFactory.getLogger(ShoppingBasketServiceIT.class);
	
    @Test
	public void testRepackage() throws IOException {
		
		final InputStream resourceStream = this.getClass().getResourceAsStream(TEST_ZIP_LOCATION);

		Assert.assertNotNull("cannot find resource at " + TEST_ZIP_LOCATION, resourceStream);
		final ZipInputStream testZip = new ZipInputStream(resourceStream);
		
		final InputStream testRepackagedZipIS = shoppingBasketService.rePackageGitLabProjectZip(testZip, "from " + TEST_ZIP_LOCATION);

		final ZipInputStream testRepackagedZip = new ZipInputStream(testRepackagedZipIS);
		
		ZipEntry entry = testRepackagedZip.getNextEntry();
		
		while(entry!=null) {
			log.info("found entry {} (directory: {})", entry.getName(), entry.isDirectory());
			Assert.assertTrue("original folder not chopped off?", !entry.getName().startsWith("junit-quality-tests-exercise-master"));
			entry = testRepackagedZip.getNextEntry();
		}
		
		testRepackagedZip.close();
	}
	

}
